=== debian/changelog ===
abpoa (1.4.1-3) unstable; urgency=medium

  * d/t/run-unit-test: do not run if a simd specific file is missing.
  * d/t/run-unit-test: compare deterministic results to reference data.
  * d/rules: move preprocessor flags definition to CPPFLAGS.
  * d/rules: SIMDe: enable native aliases in CPPFLAGS. (Closes: #1016207)

 -- Étienne Mollier <emollier@debian.org>  Wed, 03 Aug 2022 13:15:25 +0200

abpoa (1.4.1-2) unstable; urgency=medium

  * Source-only upload.
  * d/t/run-unit-test: fix dispatch to enable test of generic executable.
  * typos.patch: forwarded upstream.

 -- Étienne Mollier <emollier@debian.org>  Sat, 23 Jul 2022 21:23:15 +0200

abpoa (1.4.1-1) unstable; urgency=medium

  * Initial release. (Closes: #1014647)

 -- Étienne Mollier <emollier@debian.org>  Sat, 09 Jul 2022 19:26:20 +0200
