=== debian/control ===
Source: abpoa
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Étienne Mollier <emollier@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               cython3,
               graphviz <!nocheck>,
               libsimde-dev,
               python3-all-dev,
               zlib1g-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/abpoa
Vcs-Git: https://salsa.debian.org/med-team/abpoa.git
Homepage: https://github.com/yangao07/abPOA
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: abpoa
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
         graphviz
Built-Using: ${simde:Built-Using}
Description: adaptive banded Partial Order Alignment
 abPOA is an extended version of Partial Order Alignment (POA) that performs
 adaptive banded dynamic programming (DP) with an SIMD implementation. abPOA
 can perform multiple sequence alignment (MSA) on a set of input sequences and
 generate a consensus sequence by applying the heaviest bundling algorithm to
 the final alignment graph.
 .
 abPOA can generate high-quality consensus sequences from error-prone long
 reads and offer significant speed improvement over existing tools.
 .
 abPOA supports three alignment modes (global, local, extension) and flexible
 scoring schemes that allow linear, affine and convex gap penalties. It right
 now supports SSE2/SSE4.1/AVX2 vectorization.
 .
 For more information please refer to the paper[1] published in Bioinformatics.
 .
 [1]: https://dx.doi.org/10.1093/bioinformatics/btaa963

Package: python3-pyabpoa
Architecture: any
Section: python
Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Description: adaptive banded Partial Order Alignment - python3 module
 abPOA is an extended version of Partial Order Alignment (POA) that performs
 adaptive banded dynamic programming (DP) with an SIMD implementation. abPOA
 can perform multiple sequence alignment (MSA) on a set of input sequences and
 generate a consensus sequence by applying the heaviest bundling algorithm to
 the final alignment graph.
 .
 abPOA can generate high-quality consensus sequences from error-prone long
 reads and offer significant speed improvement over existing tools.
 .
 abPOA supports three alignment modes (global, local, extension) and flexible
 scoring schemes that allow linear, affine and convex gap penalties. It right
 now supports SSE2/SSE4.1/AVX2 vectorization.
 .
 This package provides the python3 module of abPOA.
