=== debian/changelog ===
abpoa (1.5.1-1build1) noble; urgency=medium

  * No-change rebuild with Python 3.12 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 10 Apr 2024 18:35:08 +0000

abpoa (1.5.1-1) unstable; urgency=medium

  * New upstream version

 -- Étienne Mollier <emollier@debian.org>  Fri, 19 Jan 2024 18:33:09 +0100

abpoa (1.5.0-1) unstable; urgency=medium

  * New upstream version 1.5.0
  * baseline.patch: refresh.
  * buildflags.patch: refresh.
  * d/t/run-unit-test: repair broken logic.
    This restores tests for all possible SIMDe binaries variants.

 -- Étienne Mollier <emollier@debian.org>  Sat, 13 Jan 2024 13:36:50 +0100

abpoa (1.4.3-1) unstable; urgency=medium

  * New upstream version 1.4.3
  * baseline.patch: refresh.

 -- Étienne Mollier <emollier@debian.org>  Tue, 19 Dec 2023 14:54:04 +0100

abpoa (1.4.2-1) unstable; urgency=medium

  * New upstream version 1.4.2
  * typos.patch: delete: applied upstream.
  * baseline.patch: refresh.
  * no_install_depends_cython.patch: delete: applied upstream.

 -- Étienne Mollier <emollier@debian.org>  Fri, 15 Dec 2023 11:10:45 +0100

abpoa (1.4.1-6) unstable; urgency=medium

  * Team upload.
  * No runtime dependency from cython
    Closes: #1057980

 -- Andreas Tille <tille@debian.org>  Mon, 11 Dec 2023 10:14:06 +0100

abpoa (1.4.1-5) unstable; urgency=medium

  * Migrate abpoa from experimental to unstable, since dumat didn't croak on
    the files move from bin to usr/bin in the past week.

 -- Étienne Mollier <emollier@debian.org>  Sat, 02 Dec 2023 11:31:52 +0100

abpoa (1.4.1-5~0exp0) experimental; urgency=medium

  * d/install: move files from bin to usr/bin.
    The CTTE moratorium has been lifted.  This can be migrated to unstable
    about three days later.

 -- Étienne Mollier <emollier@debian.org>  Thu, 23 Nov 2023 14:41:26 +0100

abpoa (1.4.1-4) unstable; urgency=medium

  [ Andreas Tille ]
  * Bibtex syntax for authors

  [ Étienne Mollier ]
  * d/install: flag a (blocked) install bug.
    abpoa has been accidentally installed below /bin instead of /usr/bin,
    however fixing that would go against CTTE moratorium, so just flag it
    with a big warning before someone else is tempted to fix it.
  * d/control: split python dependency for crossbuild.
    However this is not sufficient to implement fully cross compilation
    proper, as the cython3 build dependency would need to be installed as
    the native architecture to execute properly outside qemu binfmt
    context.
    Thanks to Helmut Grohne
  * d/clean: remove build artifacts not cleaned upstream.
    (Closes: #1043693, #1049682)
  * d/control: declare compliance to standards version 4.6.2.

 -- Étienne Mollier <emollier@debian.org>  Thu, 17 Aug 2023 23:18:44 +0200
