=== debian/control ===
--- 
+++ 
@@ -8,9 +8,10 @@
                cython3,
                graphviz <!nocheck>,
                libsimde-dev,
-               python3-all-dev,
+               libpython3-all-dev,
+               python3-all-dev:any,
                zlib1g-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/abpoa
 Vcs-Git: https://salsa.debian.org/med-team/abpoa.git
 Homepage: https://github.com/yangao07/abPOA
