## abpoa 1.5.2

=== debian/changelog ===
abpoa (1.5.2-1) unstable; urgency=medium

  * New upstream version 1.5.2
  * d/control: declare compliance to standards version 4.7.0.
  * buildflags.patch: refresh.
  * baseline.patch: unfuzz.
  * d/control: the build depends on python3-wheel.
  * d/t/run-unit-test: also run basic --help sorts of tests.
  * relax-cython-dep.patch: new: allow depending on cython3.
  * d/m/abpoa.1: update the manual page.
  * d/rules: check manual page version consistency.
    This ensures abpoa manual page refresh is not forgotten on newer
    upstream versions; it might be better to fully automate its
    construction though.

 -- Étienne Mollier <emollier@debian.org>  Sat, 20 Jul 2024 12:26:29 +0200
