=== debian/control ===
--- 
+++ 
@@ -10,8 +10,9 @@
                libsimde-dev,
                libpython3-all-dev,
                python3-all-dev:any,
+               python3-wheel,
                zlib1g-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/abpoa
 Vcs-Git: https://salsa.debian.org/med-team/abpoa.git
 Homepage: https://github.com/yangao07/abPOA
