=== debian/changelog ===
abpoa (1.5.3-1build3) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 13:52:15 +0000

abpoa (1.5.3-1build2) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 16:42:27 +0000

abpoa (1.5.3-1build1) plucky; urgency=medium

  * No-change rebuild to add support for Python 3.13.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Nov 2024 19:34:14 +0100

abpoa (1.5.3-1) unstable; urgency=medium

  * New upstream version 1.5.3
  * relax-cython-dep.patch: unfuzz.
  * d/m/abpoa.1: bumped date and version.
    Otherwise no changes needed.

 -- Étienne Mollier <emollier@debian.org>  Wed, 25 Sep 2024 20:52:28 +0200

abpoa (1.5.2-2) unstable; urgency=medium

  * buildflags.patch: fix preservation of CFLAGS.
  * d/control: setup.py depends on python3-setuptools. (Closes: #1080531)

 -- Étienne Mollier <emollier@debian.org>  Thu, 05 Sep 2024 21:08:54 +0200
