=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
                libsimde-dev,
                libpython3-all-dev,
                python3-all-dev:any,
+               python3-setuptools,
                python3-wheel,
                zlib1g-dev
 Standards-Version: 4.7.0
