=== debian/rules ===
--- 
+++ 
@@ -12,6 +12,14 @@
 
 %:
 	dh $@ --with=python3 --buildsystem=pybuild
+
+execute_before_dh_testdir:
+ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+	# Guard against outdated maintainer manual page.
+	# Hint: help2man does mostly the right thing except for stderr
+	# capture, multiple commands support, and commands description.
+	grep -q $(DEB_VERSION_UPSTREAM) debian/manuals/abpoa.1
+endif
 
 execute_after_dh_auto_build:
 ifeq ($(DEB_HOST_ARCH),amd64)
