=== debian/changelog ===
abpoa (1.5.5-1) unstable; urgency=medium

  * New upstream version 1.5.5
  * d/*: remove manual simde dispatch.
    By dropping the manual simde dispatch, we move to using upstream's
    runtime detection, overall making the package much lighter weight
    and the maintenance onwards easier by dropping a lot of now
    unnecessary complexity.
  * debian-simde.patch: refresh.
  * buildflags.patch: unfuzz.
  * baseline.patch: renew: only trim -march=native flags.
  * relax-cython-dep.patch: delete: applied upstream.
  * d/m/abpoa.1: document the new Heuristics for graph alignment.
  * d/t/run-unit-test: update reference data to match new results.
  * d/watch: convert to v5 Github template.
  * d/control: drop redundant Rules-Requires-Root: no.
  * d/control: declare compliance to standards version 4.7.2.
  * d/s/lintian-overrides: new: flag distutils imports.

 -- Étienne Mollier <emollier@debian.org>  Mon, 17 Nov 2025 21:58:26 +0100
