=== debian/control ===
--- 
+++ 
@@ -13,12 +13,11 @@
                python3-setuptools,
                python3-wheel,
                zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/abpoa
 Vcs-Git: https://salsa.debian.org/med-team/abpoa.git
 Homepage: https://github.com/yangao07/abPOA
 Testsuite: autopkgtest-pkg-python
-Rules-Requires-Root: no
 
 Package: abpoa
 Architecture: any
