=== debian/rules ===
--- 
+++ 
@@ -22,19 +22,7 @@
 endif
 
 execute_after_dh_auto_build:
-ifeq ($(DEB_HOST_ARCH),amd64)
-	set -e \
-	; for SIMDE in avx2 avx sse4.1 ssse3 sse3 \
-	; do	CFLAGS="$(CFLAGS) -m$${SIMDE}" \
-		CXXFLAGS="$(CXXFLAGS) -m$${SIMDE}" \
-		dh_auto_build --buildsystem=makefile -- all \
-	; 	mv -v bin/abpoa bin/abpoa.$${SIMDE} \
-	; 	dh_auto_clean --buildsystem=makefile -- clean \
-	; done
-endif
 	dh_auto_build --buildsystem=makefile -- all
-	mv -v bin/abpoa bin/abpoa.generic
-	cp debian/abpoa-dispatch.sh bin/abpoa
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
