## abpoa 1.5.6

=== Makefile ===
--- 
+++ 
@@ -197,7 +197,7 @@
 	$(CC) -c $(CFLAGS) -DABPOA_SIMD_DISPATCH -mavx512bw -I$(INC_DIR) $< -o $@
 
 install_py: setup.py python/cabpoa.pxd python/pyabpoa.pyx python/README.md
-	${py_SIMD_FLAG} python setup.py install
+	${py_SIMD_FLAG} python -m pip install .
 	
 sdist: setup.py python/cabpoa.pxd python/pyabpoa.pyx python/README.md
 	${py_SIMD_FLAG} python setup.py sdist #bdist_wheel
