=== debian/changelog ===
abpoa (1.5.6-1) unstable; urgency=medium

  * New upstream version 1.5.6
  * d/control: drop redundant Priority: optional.
  * d/control: declare compliance to standards version 4.7.3.
  * baseline.patch: fix typo in description, caught by lintian.

 -- Étienne Mollier <emollier@debian.org>  Sun, 22 Feb 2026 16:34:53 +0100
