=== debian/control ===
--- 
+++ 
@@ -1,10 +1,10 @@
 Source: abpoa
 Section: science
-Priority: optional
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Étienne Mollier <emollier@debian.org>
 Build-Depends: debhelper-compat (= 13),
                dh-python,
+               pybuild-plugin-pyproject,
                cython3,
                graphviz <!nocheck>,
                libsimde-dev,
@@ -13,7 +13,7 @@
                python3-setuptools,
                python3-wheel,
                zlib1g-dev
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/abpoa
 Vcs-Git: https://salsa.debian.org/med-team/abpoa.git
 Homepage: https://github.com/yangao07/abPOA
